#ifdef GL_ES
precision mediump float;
#endif

uniform sampler2D u_texture;
varying vec2 v_texCoord;
varying vec4 v_fragmentColor;

uniform float dy;

void main(void) {
    vec4 col = v_fragmentColor * texture2D(u_texture, v_texCoord);
    
    float y = v_texCoord.y;
    float alpha = 1.0;
    if (y > 1.0 - dy) {
        alpha = 1.0 - (y - (1.0 - dy)) / dy;
    }
    gl_FragColor = vec4(col.r * col.a * alpha, col.g * col.a * alpha, col.b * col.a * alpha, col.a * alpha);
}
