#ifdef GL_ES
precision mediump float;
#endif

//uniform sampler2D u_texture;
varying vec2 v_texCoord;
varying vec4 v_fragmentColor;

float overlay(float a, float b)
{
	if (a<0.5) {
		return 2.0*a*b;
	} else {
		return 1.0-2.0*(1.0-a)*(1.0-b);
	}
}

vec4 overlay(vec4 a, vec4 b) {
	vec4 ret;
	ret.r = overlay(a.r, b.r);
	ret.g = overlay(a.g, b.g);
	ret.b = overlay(a.b, b.b);
	ret.a = a.a;
	return ret;
}

float softlight(float a, float b) {
	if (b<0.5) {
		return 2.0*a*b+a*a*(1.0-2.0*b);
	} else {
		return 2.0*a*(1.0-b) + sqrt(a)*(2.0*b-1.0);
	}
}

vec4 softlight(vec4 a, vec4 b) {
	vec4 ret;
	ret.r = softlight(a.r, b.r);
	ret.g = softlight(a.g, b.g);
	ret.b = softlight(a.b, b.b);
	ret.a = a.a;
	return ret;
}


void main(void) {
    // Convert to greyscale using NTSC weightings
    vec4 col = texture2D(CC_Texture0, v_texCoord);

//    gl_FragColor = vec4(r,g,b , col.a);
	gl_FragColor = overlay(softlight(col, vec4(0.3,0.65,1.0,1.0)), vec4(1.0,1.0,1.0,1.0));

}
